#pragma semicolon 1

#include <ws_store>
#include <sdktools_functions>

public Plugin:myinfo = 
{
	name	= "STORE (Enemy Skin)",
	author	= "wS (World-Source.Ru)",
	version = "1.1"
};

new g_Price, g_CategoryID, g_ItemID;
new g_bHaveEnemySkin[MAXPLAYERS + 1] = {false, ...};
new Handle:g_hTTSkins_Array = INVALID_HANDLE, Handle:g_hCTSkins_Array = INVALID_HANDLE;

public OnPluginStart()
{
	CreateTimer(1.0, START);
}

public OnMapStart()
{
	wS_Precache(g_hTTSkins_Array);
	wS_Precache(g_hCTSkins_Array);
}

public OnPluginEnd()
{
	if (g_CategoryID > 0 && !STORE_DeleteCategoryByID(g_CategoryID, true) && g_ItemID > 0)
		STORE_RemoveItemFromCategory(g_CategoryID, g_ItemID);
}

public STORE_Loaded()
{
	g_CategoryID = 0; g_ItemID = 0;
	decl String:PluginName[150]; PluginName[0] = '\0'; GetPluginFilename(GetMyHandle(), PluginName, 150);
	ServerCommand("sm plugins reload \"%s\"", PluginName);
}

public Action:START(Handle:timer)
{
	/////
	new Handle:kv = CreateKeyValues("store_enemy_skin");

	if (!FileToKeyValues(kv, "cfg/store/modules/store_enemy_skin.txt"))
		SetFailState("Error in cfg/store/modules/store_enemy_skin.txt");

	decl String:CategoryName[STORE_CATEGORY_LENGTH];
	KvGetString(kv, "CategoryName", CategoryName, STORE_CATEGORY_LENGTH);
	if (TrimString(CategoryName) < 1)
		SetFailState("Категория не указана");

	new bool:bCategoryExist = (g_CategoryID = STORE_GetCategoryID(CategoryName)) > 0;
	decl String:Text[STORE_ITEMTEXT_LENGTH], String:str_flag[10];

	if (!bCategoryExist)
	{
		KvGetString(kv, "CategoryText", Text, STORE_ITEMTEXT_LENGTH);
		KvGetString(kv, "CategoryFlag", str_flag, 10);

		if ((g_CategoryID = STORE_CreateCategory(CategoryName, Text, str_flag)) < 1)
			SetFailState("Не удалось создать категорию '%s'", CategoryName);
	}

	g_Price = KvGetNum(kv, "price");
	KvGetString(kv, "ItemText", Text, STORE_ITEMTEXT_LENGTH);
	if (TrimString(Text) > 0)
	{
		KvGetString(kv, "ItemFlag", str_flag, 10);
		if ((g_ItemID = STORE_AddItemToCategory(g_CategoryID, Text, g_Price, true, MyCallBack, str_flag)) < 1)
		{
			if (!bCategoryExist)
			{
				STORE_DeleteCategoryByID(g_CategoryID, true);
				g_CategoryID = 0;
			}
			SetFailState("Не удалось добавить функцию '%s'", Text);
		}
	}
	else if (bCategoryExist)
		SetFailState("Укажите уникальное название категории или используйте ItemText");

	CloseHandle(kv);
	/////

	g_hTTSkins_Array = CreateArray(75);
	g_hCTSkins_Array = CreateArray(75);

	if (GetEngineVersion() == Engine_CSGO)
	{
		PushArrayString(g_hTTSkins_Array, "tm_anarchist");
		PushArrayString(g_hTTSkins_Array, "tm_pirate");
		PushArrayString(g_hTTSkins_Array, "tm_professional");
		PushArrayString(g_hTTSkins_Array, "tm_separatist");
		PushArrayString(g_hTTSkins_Array, "tm_balkan_varianta");
		PushArrayString(g_hTTSkins_Array, "tm_leet");
		PushArrayString(g_hTTSkins_Array, "tm_phoenix");

		PushArrayString(g_hCTSkins_Array, "ctm_gign");
		PushArrayString(g_hCTSkins_Array, "ctm_gsg9");
		PushArrayString(g_hCTSkins_Array, "ctm_st6");
		PushArrayString(g_hCTSkins_Array, "ctm_fbi");
		PushArrayString(g_hCTSkins_Array, "ctm_idf");
		PushArrayString(g_hCTSkins_Array, "ctm_sas");
		PushArrayString(g_hCTSkins_Array, "ctm_swat");
	}
	else
	{
		PushArrayString(g_hTTSkins_Array, "t_arctic");
		PushArrayString(g_hTTSkins_Array, "t_guerilla");
		PushArrayString(g_hTTSkins_Array, "t_leet");
		PushArrayString(g_hTTSkins_Array, "t_phoenix");

		PushArrayString(g_hCTSkins_Array, "ct_gign");
		PushArrayString(g_hCTSkins_Array, "ct_gsg9");
		PushArrayString(g_hCTSkins_Array, "ct_sas");
		PushArrayString(g_hCTSkins_Array, "ct_urban");
	}

	wS_Precache(g_hTTSkins_Array);
	wS_Precache(g_hCTSkins_Array);

	HookEvent("player_spawn", player_spawn, EventHookMode_Post);
	return Plugin_Stop;
}


///


public MyCallBack(client, const String:steamid[], CategoryID, ItemID, ItemPrice)
{
	if (ItemID == g_ItemID)
		wS_OnClientSelect(client, LastMenuItem:MI_InCategory);
}

public STORE_OnClientSelectEmptyCategory(client, const String:steamid[], CategoryID)
{
	if (CategoryID == g_CategoryID)
		wS_OnClientSelect(client, LastMenuItem:MI_Main);
}

stock wS_OnClientSelect(client, LastMenuItem:MI)
{
	if (!IsPlayerAlive(client))
	{
		PrintCenterText(client, "Вы мертвы");
		STORE_ShowMenu(client, MI);
		return;
	}

	if (g_bHaveEnemySkin[client])
	{
		PrintCenterText(client, "Вы уже купили вражеский скин");
		STORE_ShowMenu(client, MI);
		return;
	}

	if (g_Price > 0)
	{
		new credits = STORE_GetCredits(client);

		if (credits < g_Price)
		{
			PrintCenterText(client, "Вам не хватает %d кр", (g_Price - credits));
			STORE_ShowMenu(client, MI);
			return;
		}

		if (!STORE_SetCredits(client, (credits - g_Price)))
		{
			LogError("Не удалось установить кредиты игроку '%N'", client);
			return;
		}
	}

	g_bHaveEnemySkin[client] = true;

	decl String:model[75];
	new Handle:Ar = GetClientTeam(client) == 3 ? g_hTTSkins_Array : g_hCTSkins_Array;
	GetArrayString(Ar, GetRandomInt(0, GetArraySize(Ar)-1), model, 75);
	Format(model, 75, "models/player/%s.mdl", model);
	SetEntityModel(client, model);
	PrintToChat(client, "\x04Вам установлен вражеский скин");

	STORE_ShowMenu(client, MI);
}


///


stock wS_Precache(Handle:Ar)
{
	if (Ar == INVALID_HANDLE)
		return;

	new count = GetArraySize(Ar);
	decl String:model[75];

	for (new i = 0; i < count; i++)
	{
		GetArrayString(Ar, i, model, 75);
		Format(model, 75, "models/player/%s.mdl", model);
		PrecacheModel(model, true);
	}
}

public player_spawn(Handle:event, const String:name[], bool:silent)
{
	g_bHaveEnemySkin[GetClientOfUserId(GetEventInt(event, "userid"))] = false;
}